/* $Id$

This file is part of libmspal
Copyright © 2008 Mikko Rasa, Mikkosoft Productions
Distributed under the LGPL
*/

#ifndef MSP_AL_SOUND_H_
#define MSP_AL_SOUND_H_

#include <string>
#include <vorbis/vorbisfile.h>
#include "format.h"

namespace Msp {
namespace AL {

class Sound
{
private:
	OggVorbis_File ovfile;
	unsigned freq;
	unsigned size;
	char *data;
	Format format;
	unsigned read_pos;
	bool eof_flag;

public:
	Sound();
	Sound(const std::string &);
	~Sound();

	void open(const std::string &);
	void load_data();
	void load(const std::string &);
	void close();
	void rewind();
	unsigned read(char *, unsigned);
	bool eof() const { return eof_flag; }

	Format get_format() const { return format; }
	unsigned get_frequency() const { return freq; }
	unsigned get_size() const { return size; }
	const char *get_data() const;
};

} // namespace AL
} // namespace Msp

#endif
